#define freesize() ((size_t)(ramend-ramfree))
#define start(ft) ((ft)->start)
#define fend(ft) ((ft)->fend)

int memory (int slot, long size);
int init_ram (void);
void exit_ram (void);
int finsert (int slot, char *p, size_t size);
void fdelete (int slot, char *p, size_t size);
void freset (int slot);

char *next_line (char *line, filetyp *ft);
char *prev_line (char *line, filetyp *ft);

int find_pos (char *line, int pos, char *end, char **res,
	int tabsize);
int position (char *line, char *end, int tabs, char *p);

void load_it (char *name, int slot, int flag);
void load_file (void);
void do_load (char *name);
int save_it (int slot);

void from_undo (void);
void to_undo (char *p, size_t size, int slot);
int end_program (void);

void get_arguments (int argc, char *argv[]);

void open_gap (char *p, int slot);
void close_gap (int slot);
void update_gap (char *p, int slot);
